# Update an API credential

To update an existing API credential, send a `PATCH` request to the `/api/api_credentials/:id` endpoint, where `id` is the ID of the resource that you want to update.

Here below the list of all the possible arguments that you can pass with the request body.

## Request

**PATCH** <https://provisioning.commercelayer.io/ap&#x69;**/api\\_credentials/:id>\*\*

### Arguments

| Body Parameter                   | Type      | Required |
| -------------------------------- | --------- | -------- |
| **type**                         | `string`  | Required |
| **id**                           | `string`  | Required |
| attributes.**name**              | `string`  | Optional |
| attributes.**redirect\_uri**     | `string`  | Optional |
| attributes.**expires\_in**       | `integer` | Optional |
| attributes.**reference**         | `string`  | Optional |
| attributes.**reference\_origin** | `string`  | Optional |
| attributes.**metadata**          | `object`  | Optional |
| relationships.**role**           | `object`  | Optional |

### Example

{% tabs %}
{% tab title="Request" %}
The following request updates the API credential identified by the ID "xYZkjABcde":

```sh
curl -g -X PATCH \
  'https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde' \
  -H 'Accept: application/vnd.api+json' \
  -H 'Authorization: Bearer {{your_access_token}}' \
  -H 'Content-Type: application/vnd.api+json' \
  -d '{
  "data": {
    "type": "api_credentials",
    "id": "xYZkjABcde",
    "attributes": {
      "reference": "ANY-EXTERNAL-REFEFERNCE"
    },
    "relationships": {
      "role": {
        "data": {
          "type": "roles",
          "id": "ABCRtyUpBa"
        }
      }
    }
  }
}'
```

{% endtab %}

{% tab title="Response" %}
On success, the API responds with a `200 OK` status code, returning the updated resource object:

```javascript
{
  "data": {
    "id": "xYZkjABcde",
    "type": "api_credentials",
    "links": {
      "self": "https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde"
    },
    "attributes": {
      "name": "My app",
      "kind": "sales_channel",
      "confidential": true,
      "redirect_uri": "https://bluebrand.com/img/logo.svg",
      "client_id": "xxxx-yyyy-zzzz",
      "client_secret": "xxxx-yyyy-zzzz",
      "scopes": "market:all market:9 market:122 market:6 stock_location:6 stock_location:33",
      "expires_in": 7200,
      "mode": "test",
      "custom": false,
      "created_at": "2018-01-01T12:00:00.000Z",
      "updated_at": "2018-01-01T12:00:00.000Z",
      "reference": "ANY-EXTERNAL-REFEFERNCE",
      "reference_origin": "ANY-EXTERNAL-REFEFERNCE-ORIGIN",
      "metadata": {
        "foo": "bar"
      }
    },
    "relationships": {
      "organization": {
        "links": {
          "self": "https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde/relationships/organization",
          "related": "https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde/organization"
        }
      },
      "role": {
        "links": {
          "self": "https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde/relationships/role",
          "related": "https://provisioning.commercelayer.io/api/api_credentials/xYZkjABcde/role"
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}
